import 'dart:collection';
import 'dart:convert';
import 'dart:math';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:charts_flutter/flutter.dart' as charts;
import 'package:rapid_widgets_library/consts.dart' as con;

import 'package:http/http.dart' as http;
import 'package:rapid_widgets_library/widget-classesUsed.dart';
class CustomChart extends StatefulWidget {
  final Chartparms chartparms;
  CustomChart({ this.chartparms});

  @override
  _CustomChartState createState() => _CustomChartState();
}

class _CustomChartState extends State<CustomChart> {


  @override
  Widget build(BuildContext context) {
    print('aaaaa');
    if(widget.chartparms.apiUrl=='null'){
      if (widget.chartparms.ChartType == 'PieChart') {
        return _createPieChart(widget.chartparms.series, widget.chartparms.arcValue, widget.chartparms.labelFontSize);
      }
      if (widget.chartparms.ChartType == 'BarChart') {
        return _createBarChart(widget.chartparms.series);
      }

      if (widget.chartparms.ChartType == 'LineChart') {
        return _createLineChart(widget.chartparms.series);
      }
    }

    else {
      return FutureBuilder(
          future: fetchDataFromAPI(widget.chartparms.apiUrl),
          builder: (context, AsyncSnapshot newsnapshot) {
            List<Series>s = [];
            List<Map<String, dynamic>>lmap = [];
            if(newsnapshot.hasData){
              Map<dynamic,dynamic>dmap =new HashMap();
              var x = newsnapshot.requireData;
              var j = x[widget.chartparms.apiPath];
              print(j.runtimeType);
              //var z = jsonDecode(j);
              List list1 = [];
              list1.add(j);
              print(list1);

              /*if(j.runtimeType.toString()=='List<dynamic>'){
            print("sfcjhbnklnffklnbd");
          }*/


              /* var abc = getDataFromAPIPath(widget.chartparms.apiPath,newsnapshot.requireData);
          print("abc"+'${abc}');*/
              /*List list = abc;
          print(list);*/


              /* if(abc!=null){
                  for(int i = 0; i<widget.chartparms.comparisonVal.length;i++){
                    var q = getDataFromAPIPath(widget.chartparms.comparisonVal[i], abc);
                    print("q"+'${q}');
                  }
           }*/


              final List<charts.Color> circleColors = [
                charts.MaterialPalette.red.shadeDefault,
                charts.MaterialPalette.blue.shadeDefault,
                charts.MaterialPalette.green.shadeDefault,
                charts.MaterialPalette.indigo.shadeDefault,
                charts.MaterialPalette.deepOrange.shadeDefault,
                charts.MaterialPalette.purple.shadeDefault,
                charts.MaterialPalette.yellow.shadeDefault,
                charts.MaterialPalette.gray.shadeDefault,
                charts.MaterialPalette.cyan.shadeDefault,
                charts.MaterialPalette.lime.shadeDefault,
                charts.MaterialPalette.pink.shadeDefault,
                charts.MaterialPalette.teal.shadeDefault,
                charts.MaterialPalette.red.shadeDefault,
                charts.MaterialPalette.blue.shadeDefault,
                charts.MaterialPalette.green.shadeDefault,
                charts.MaterialPalette.indigo.shadeDefault,
                charts.MaterialPalette.deepOrange.shadeDefault,
                charts.MaterialPalette.purple.shadeDefault,
                charts.MaterialPalette.yellow.shadeDefault,
                charts.MaterialPalette.gray.shadeDefault,
                charts.MaterialPalette.cyan.shadeDefault,
                charts.MaterialPalette.lime.shadeDefault,
                charts.MaterialPalette.pink.shadeDefault,
                charts.MaterialPalette.teal.shadeDefault,
                charts.MaterialPalette.purple.shadeDefault,
                charts.MaterialPalette.yellow.shadeDefault,
                charts.MaterialPalette.gray.shadeDefault,
                charts.MaterialPalette.cyan.shadeDefault,
                charts.MaterialPalette.lime.shadeDefault,
                charts.MaterialPalette.pink.shadeDefault,
                charts.MaterialPalette.teal.shadeDefault,
                charts.MaterialPalette.red.shadeDefault,
                charts.MaterialPalette.blue.shadeDefault,
                charts.MaterialPalette.cyan.shadeDefault,
                charts.MaterialPalette.lime.shadeDefault,
                charts.MaterialPalette.pink.shadeDefault,
                charts.MaterialPalette.teal.shadeDefault,
                charts.MaterialPalette.purple.shadeDefault,
                charts.MaterialPalette.yellow.shadeDefault,
                charts.MaterialPalette.gray.shadeDefault,
                charts.MaterialPalette.gray.shadeDefault,
                charts.MaterialPalette.cyan.shadeDefault,
                charts.MaterialPalette.lime.shadeDefault,
                charts.MaterialPalette.pink.shadeDefault,
                charts.MaterialPalette.teal.shadeDefault,
                charts.MaterialPalette.purple.shadeDefault,
                charts.MaterialPalette.yellow.shadeDefault,
                charts.MaterialPalette.gray.shadeDefault,
              ];


              print("Lmap"+'${lmap}');
              for(int r =0;r<widget.chartparms.comparisonVal.length;r++) {
                print(r);
                if(j.runtimeType.toString()=='List<dynamic>'){
                  for (var k in j) {
                    print(k.toString());
                    Map<String, dynamic> propsMap = new HashMap();

                    propsMap.putIfAbsent(
                        widget.chartparms.comparisonVal[r], () => k[widget
                        .chartparms.comparisonVal[r]]);
                    lmap.add(propsMap);
                  }
                }
                else{
                  for (var k in list1) {
                    print(k.toString());
                    Map<String, dynamic> propsMap = new HashMap();

                    propsMap.putIfAbsent(
                        widget.chartparms.comparisonVal[r], () => k[widget
                        .chartparms.comparisonVal[r]]);
                    lmap.add(propsMap);
                  }
                }

              }
              print(lmap);

              for (int z = 0; z < lmap.length; z++) {
                /* s.add(Series(year: widget.chartparms.comparisonVal[z].toString(),
                        subscribers: list[z].round()));*/
                for(var key in lmap[z].keys){
                  s.add(Series(year: key.toString(),
                      subscribers: lmap[z][key].round(),
                      color: (widget.chartparms.sameColor == true) ?
                      (widget.chartparms.barColor != null) ? charts.ColorUtil
                          .fromDartColor(widget.chartparms.barColor) : charts
                          .MaterialPalette.blue.shadeDefault :
                      circleColors[z]
                  ));
                }

              }
            }
            List<charts.Series<Series, String>> series = [
              charts.Series(
                id: "TIME - POINT",
                data: s,
                domainFn: (Series series, _) => series.year.toString(),
                measureFn: (Series series, _) => series.subscribers,
                colorFn: (Series series, __) => series.color,
                labelAccessorFn: (Series series, _) => '${series.year}',
              )
            ];
            List<charts.Series<Series, int>> series1 = [
              charts.Series(
                id: "TIME - POINT",
                data: s,
                domainFn: (Series series, _) => series.subscribers,
                measureFn: (Series series, _) => series.subscribers,
                colorFn: (Series series, __) => series.color,
                labelAccessorFn: (Series series, _) => '${series.year}',
              )
            ];

            List<charts.Series<Series, String>> series2 = [
              charts.Series(
                id: "TIME - POINT",
                data: s,
                domainFn: (Series series, _) => series.year.toString(),
                measureFn: (Series series, _) => series.subscribers,
                colorFn: (Series series, __) => series.color,
                labelAccessorFn: (Series series, _) => '${series.year}',
              ),
              charts.Series(
                id: "TIME - POINT",
                data: s,
                domainFn: (Series series, _) => series.year.toString(),
                measureFn: (Series series, _) => series.subscribers,
                colorFn: (_, __) => charts.MaterialPalette.gray.shadeDefault,
                labelAccessorFn: (Series series, _) => '${series.year}',
              )..setAttribute(charts.rendererIdKey, 'customLine'),
            ];

            if(widget.chartparms.ChartType=='PieChart'){
              return _createPieChart(series, widget.chartparms.arcValue, widget.chartparms.labelFontSize);
            }
            if(widget.chartparms.ChartType=='BarChart'){
              return _createBarChart(series);
            }

            if(widget.chartparms.ChartType=='LineChart'){
              return _createLineChart(series1);
            }

            if(widget.chartparms.ChartType=='HorizontalBarChart'){
              return _createHorzontalBarChart(series);
            }


            if(widget.chartparms.ChartType=='BarLineChart'){
              print('BarLineChart');
              return _OrdinalComboBarLineChart(series2);
            }
            else{
              return Container();
            }
          }

      );
    }
  }

  Widget _createPieChart(List<charts.Series<dynamic, dynamic>> objSeries,
      int arcValue, int labelFontSize) {
    charts.PieChart mPieChart;

    mPieChart = new charts.PieChart(
      objSeries,
      animate: true,
      animationDuration: Duration(seconds: 2),
      defaultRenderer: new charts.ArcRendererConfig(
          arcWidth: (arcValue != null) ? arcValue : 5,
          arcRendererDecorators: [
            new charts.ArcLabelDecorator(
              outsideLabelStyleSpec:
              new charts.TextStyleSpec(
                  fontSize: (labelFontSize != null) ? labelFontSize : 10),
              labelPosition: charts.ArcLabelPosition.auto,
            )
          ]),
      behaviors: [
        new charts.DatumLegend(
          position: charts.BehaviorPosition.bottom,
          outsideJustification: charts.OutsideJustification.middleDrawArea,
          horizontalFirst: false,
          desiredMaxRows: (widget.chartparms.desiredMaxRows != null) ? widget
              .chartparms.desiredMaxRows : 1,
        )
      ],
    );
    return mPieChart;
  }

  Widget _createBarChart(List<charts.Series<dynamic, dynamic>> objSeries) {
    charts.BarChart mBarChart;
    mBarChart = new charts.BarChart(
      objSeries,
      animate: true,
      vertical:true,
      barGroupingType: charts.BarGroupingType.stacked,
      animationDuration: Duration(seconds: con.intTwo),

      behaviors: [
        new charts.DatumLegend(
          position: charts.BehaviorPosition.bottom,
          outsideJustification: charts.OutsideJustification.middleDrawArea,
          horizontalFirst: false,
          desiredMaxRows: (widget.chartparms.desiredMaxRows != null) ? widget
              .chartparms.desiredMaxRows : 0,
        )
      ],
      defaultRenderer: new charts.BarRendererConfig(
        cornerStrategy:  charts.ConstCornerStrategy((widget.chartparms.barChartRadius!=null)?widget.chartparms.barChartRadius:5),
      ),
    );

    return mBarChart;
  }


  Widget _createHorzontalBarChart(List<charts.Series<dynamic, dynamic>> objSeries) {
    charts.BarChart mBarChart;
    mBarChart = new charts.BarChart(
      objSeries,
      animate: true,
      vertical:false,
      animationDuration: Duration(seconds: con.intTwo),

      behaviors: [
        new charts.DatumLegend(
          position: charts.BehaviorPosition.bottom,
          outsideJustification: charts.OutsideJustification.middleDrawArea,
          horizontalFirst: false,
          desiredMaxRows: (widget.chartparms.desiredMaxRows != null) ? widget
              .chartparms.desiredMaxRows : 0,
        )
      ],
      defaultRenderer: new charts.BarRendererConfig(
        cornerStrategy:  charts.ConstCornerStrategy((widget.chartparms.barChartRadius!=null)?widget.chartparms.barChartRadius:5),
      ),
    );

    return mBarChart;
  }




  Widget _createLineChart(List<charts.Series<dynamic, dynamic>> objSeries) {
    charts.LineChart mLineChart;
    mLineChart = charts.LineChart(objSeries,
        animationDuration: Duration(seconds: 5),
        animate: true,
        behaviors: [
          new charts.DatumLegend(
            position: charts.BehaviorPosition.bottom,
            showMeasures: true,
            outsideJustification: charts.OutsideJustification.middleDrawArea,
            horizontalFirst: false,
            desiredMaxRows: (widget.chartparms.desiredMaxRows != null) ? widget
                .chartparms.desiredMaxRows : 0,
          )
        ],
        defaultRenderer: new charts.LineRendererConfig(
            includeArea: true, stacked: false, includePoints: true));
    return mLineChart;
  }

  Widget _OrdinalComboBarLineChart(List<charts.Series<dynamic, dynamic>> objSeries){
    return new charts.OrdinalComboChart(
        objSeries,
        animate: true,
        behaviors: [
          new charts.DatumLegend(
            position: charts.BehaviorPosition.bottom,
            outsideJustification: charts.OutsideJustification.middleDrawArea,
            horizontalFirst: false,
            desiredMaxRows: (widget.chartparms.desiredMaxRows != null) ? widget
                .chartparms.desiredMaxRows : 0,
          )
        ],
        animationDuration: Duration(seconds: 2),
        // Configure the default renderer as a bar renderer.
        defaultRenderer: new charts.BarRendererConfig(
          groupingType: charts.BarGroupingType.grouped,
          cornerStrategy:  charts.ConstCornerStrategy((widget.chartparms.barChartRadius!=null)?widget.chartparms.barChartRadius:5),

        ),
        // Custom renderer configuration for the line series. This will be used for
        // any series that does not define a rendererIdKey.
        customSeriesRenderers: [
          new charts.LineRendererConfig(
            // ID used to link series to this renderer.
              customRendererId: 'customLine')
        ]);
  }

}
fetchDataFromAPI(String api) async {
  // print("API");
  // print(api);
  if (api == null) {
    return;
  }
  final response = await http.get(
      Uri.parse(api)); //(API_URL+'processAPILink?api=" + api);
  if (response.statusCode == 200) {
    //print(json.decode(response.body));
    return json.decode(response.body);
  }
}
class Series {
  final String year;
  final int subscribers;
  final charts.Color color;


  Series(
      {
        this.year,
        this.subscribers,
        this.color
      }
      );
}