import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:rapid_widgets_library/widget-classesUsed.dart';

class CustomTextField extends StatefulWidget {
  final TFparams tFparams;
  CustomTextField({this.tFparams});

  @override
  _CustomTextFieldState createState() => _CustomTextFieldState();
}

class _CustomTextFieldState extends State<CustomTextField> {
  @override
  Widget build(BuildContext context) {
    final TextEditingController controller = new TextEditingController();
    String change = '';
    return TextField(
      maxLength:
          (widget.tFparams.maxLength != null) ? widget.tFparams.maxLength : 50,
      maxLengthEnforced: (widget.tFparams.maxLengthEnforced != null)
          ? widget.tFparams.maxLengthEnforced
          : false,
      obscureText: (widget.tFparams.obescureText != null)
          ? widget.tFparams.obescureText
          : false,
      //controller: controller,
      decoration: (widget.tFparams.prefixIcon != null)
          ? InputDecoration(
              hintText: (widget.tFparams.hintText != 'null')
                  ? widget.tFparams.hintText
                  : '',
              labelText: (widget.tFparams.hintText != 'null')
                  ? widget.tFparams.labelText
                  : '',
              prefixIcon: Icon(
                widget.tFparams.prefixIcon,
                color: widget.tFparams.iconColor ?? Colors.transparent,
              ),
              suffixIcon: Icon(
                widget.tFparams.suffixIcon,
                color: widget.tFparams.iconColor ?? Colors.transparent,
              ),
              fillColor: (widget.tFparams.fillColor != null)
                  ? widget.tFparams.fillColor
                  : Colors.transparent,
              filled: (widget.tFparams.filled != null)
                  ? widget.tFparams.filled
                  : false,
              border: OutlineInputBorder(
                borderRadius: BorderRadius.circular(
                    (widget.tFparams.borderRadius != null)
                        ? widget.tFparams.borderRadius
                        : 0),
                borderSide: BorderSide(
                    color: widget.tFparams.borderColor,
                    style: BorderStyle.solid,
                    width: 5),
              ))
          : InputDecoration(
              hintText: (widget.tFparams.hintText != 'null')
                  ? widget.tFparams.hintText
                  : '',
              labelText: (widget.tFparams.hintText != 'null')
                  ? widget.tFparams.labelText
                  : '',
              //prefixIcon: Icon(widget.tFparams.prefixIcon,color: widget.tFparams.iconColor??Colors.transparent,),
              suffixIcon: Icon(
                widget.tFparams.suffixIcon,
                color: widget.tFparams.iconColor ?? Colors.transparent,
              ),
              fillColor: (widget.tFparams.fillColor != null)
                  ? widget.tFparams.fillColor
                  : Colors.transparent,
              filled: (widget.tFparams.filled != null)
                  ? widget.tFparams.filled
                  : false,
              border: OutlineInputBorder(
                borderRadius: BorderRadius.circular(
                    (widget.tFparams.borderRadius != null)
                        ? widget.tFparams.borderRadius
                        : 0),
                borderSide: BorderSide(
                    color: widget.tFparams.borderColor,
                    style: BorderStyle.solid,
                    width: 5),
              )),
      cursorColor: widget.tFparams.cursorColor ?? Colors.blueAccent,
      cursorHeight: widget.tFparams.cursorHeight ?? 20,
      cursorWidth: widget.tFparams.cursorWidth ?? 2,
      showCursor: (widget.tFparams.showCursor != null)
          ? widget.tFparams.showCursor
          : true,
      style: TextStyle(color: widget.tFparams.textColor ?? Colors.black54),
      onChanged: (String temp) {
        setState(() {
          change = temp;
        });
        //print(e);
      },
    );
  }
}
